------------------------------------------------------------------------------
-- --------------------        M a R T E   O S          ------------------- --
------------------------------------------------------------------------------
--                                                             V1.61B   070119
--
--                       'S i g n a l s _ V a l u e s'
--
--                                   Spec
--
--
--  File 'signals_values.ads'                                          By MAR.
--
--  MaRTE signals values.
--
--  The values assigned here are used in 'Kernel.Signals' to define
--  the kernel signals.
--
--  The signals descriptions are in the package 'Signals_Info'.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

package Signals_Values is
   pragma Preelaborate;

   SIGNULL    : constant :=  0;
   SIGHUP     : constant :=  1;
   SIGINT     : constant :=  2;
   SIGQUIT    : constant :=  3;
   SIGILL     : constant :=  4;
   SIGTRAP    : constant :=  5; -- Used by GNAT
   SIGABRT    : constant :=  6;
   SIGBUS     : constant :=  7;
   SIGFPE     : constant :=  8;
   SIGKILL    : constant :=  9;
   SIGUSR1    : constant := 10;
   SIGSEGV    : constant := 11;
   SIGUSR2    : constant := 12;
   SIGPIPE    : constant := 13;
   SIGALRM    : constant := 14;
   SIGTERM    : constant := 15;
   SIGCHLD    : constant := 17;
   SIGCONT    : constant := 18;
   SIGSTOP    : constant := 19;
   SIGTSTP    : constant := 20;
   SIGTTIN    : constant := 21;
   SIGTTOU    : constant := 22;
   SIGVTALRM  : constant := 26; -- Used by GNAT
   SIGPROF    : constant := 27;
   SIGUNUSED  : constant := 31; -- Used by GNAT

   SIGRTMIN   : constant := 32;
   SIGRTMAX   : constant := 63; --  By now should be between 32 and 63
   --  SIGRTMAX also indicates the last valid value for a signal.
end Signals_Values;
