------------------------------------------------------------------------------
----------------------        M a R T E     O S        -----------------------
------------------------------------------------------------------------------
--                                                             V1.61B   070119
--
--                     'I n t e r r u p t _ T a b l e s'
--
--                                 Body
--
--
--  File 'interrupt_tables.adb'                  By Miguel ngel Masmano Tello
--                                                  and MAR.
--
--
--  Linux interrupt tables management.
--
--  The idea of running MaRTE OS as a Linux process is due to Miguel Angel
--  Masmano     Tello     (Universidad    Politecnica     de     Valencia)
--  <mimastel@doctor.upv.es>.
--  He  is  also  the  author  of   most  of  the  code  involved  in  the
--  implementation of the hardware interface for this architecture.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
------------------------------------------------------------------------------

package body Interrupt_Tables is

   ----------------
   -- Inicialize --
   ----------------
   procedure Inicialize is
      procedure Interrupts_Inicialize_Signal_Handlers_Table;
      pragma Import (C, Interrupts_Inicialize_Signal_Handlers_Table,
                       "interrupts_inicialize_signal_handlers_table");
   begin
      Interrupts_Inicialize_Signal_Handlers_Table;
   end Inicialize;

end Interrupt_Tables;
