------------------------------------------------------------------------------
--  ------------------         M a R T E   O S         -------------------  --
------------------------------------------------------------------------------
--                                                             V1.61B   070119
--
--                       'S e r i a l _ C o n s o l e'
--
--                                 Body
--
--
--  File 'serial_console.adb'                                         By MAR.
--
--  Allows programs to change the output system console between the monitor
--  and the serial line.
--
--  ----------------------------------------------------------------------
--   Copyright (C) 2000-2007, Universidad de Cantabria, SPAIN
--
--   MaRTE OS web page: http://marte.unican.es
--   Contact Addresses: Mario Aldea Rivas          aldeam@unican.es
--                      Michael Gonzalez Harbour      mgh@unican.es
--
--  MaRTE OS  is free software; you can  redistribute it and/or  modify it
--  under the terms of the GNU General Public License  as published by the
--  Free Software Foundation;  either  version 2, or (at  your option) any
--  later version.
--
--  MaRTE OS  is distributed  in the  hope  that  it will be   useful, but
--  WITHOUT  ANY  WARRANTY;     without  even the   implied   warranty  of
--  MERCHANTABILITY  or  FITNESS FOR A  PARTICULAR PURPOSE.    See the GNU
--  General Public License for more details.
--
--  You should have received  a  copy of  the  GNU General Public  License
--  distributed with MaRTE  OS;  see file COPYING.   If not,  write to the
--  Free Software  Foundation,  59 Temple Place  -  Suite 330,  Boston, MA
--  02111-1307, USA.
--
--  As a  special exception, if you  link this  unit  with other  files to
--  produce an   executable,   this unit  does  not  by  itself cause  the
--  resulting executable to be covered by the  GNU General Public License.
--  This exception does  not however invalidate  any other reasons why the
--  executable file might be covered by the GNU Public License.
--
-------------------------------------------------------------------------------
with Drivers_MaRTE;
with Text_And_Serial_Console_Ioctl;
with Basic_Integer_Types;

package body Serial_Console is

   package T_S_Cons renames Text_And_Serial_Console_Ioctl;

   ----------------------------------------------------------------------------
   -- Function Ioctl of the text and serial console ---------------------------
   ----------------------------------------------------------------------------
   function Ioctl
     (Fd             : in     Drivers_MaRTE.File_Descriptor;
      Request        : in     T_S_Cons.Ioctl_Commads;
      Ioctl_Data     : access T_S_Cons.Ioctl_Data_Not_Used)
     return Basic_Integer_Types.Int;
   pragma Import (C, Ioctl, "text_and_serial_console_ioctl");
   Ret : Basic_Integer_Types.Int;

   -------------------------
   -- Serial_Console_Init --
   -------------------------
   procedure Serial_Console_Init is
   begin
      Ret := Ioctl (1, T_S_Cons.Change_To_Serial_Console,
                    T_S_Cons.Data_Not_Used'Access);
   end Serial_Console_Init;

   ---------------------------
   -- Standard_Console_Init --
   ---------------------------
   procedure Standard_Console_Init is
   begin
      Ret := Ioctl (1, T_S_Cons.Change_To_Text_Console,
                    T_S_Cons.Data_Not_Used'Access);
   end Standard_Console_Init;

end Serial_Console;
