# Global Data

# Paths
$MPATH = "root_instalation_path";
$GNAT_PATH = "gnat_instalation_path";

$GNAT_VERSION = "_gnat_version_number_";
$ARCH = "_arch_";

# jRate PATH
$JRATE_PATH = "/invalid_JRATE_PATH_in_marte/utils/globals.pl";
# Directory that contains 'jRate/' and 'jRate-gcc/'. To use only with
# the jRate port to MaRTE (under development).

# Boot parameters
$HOST_IP_NUM = "_host_ip_num_";
$EXPORTED_DIR = "_exported_directory_";
$TARGET_IP_DIR = "_target_domain_name_";

# Target architecture
$PENTIUM_TARGET = "_pentium_target_";
$P6_TARGET = "_p6_target_";
$VIRTUAL_TIMER = "_use_itimer_";

# Silent (mgcc works silently)
$SILENT=0;

# Add hostname to program name (useful in a lab with several hosts and
# targets an only one dhcp server).
$ADD_HOSTNAME_TO_MPROGRAM="FALSE";

# Tools
$GNATMAKE   ="gnatmake";
$GNATBIND   ="gnatbind";
$GNATLINK   ="gnatlink";
$GCC        ="gcc";
$Mld        ="$MPATH/utils/mld";
$Mgcc       ="$MPATH/utils/mgcc";
$MKKERNEL   ="$MPATH/utils/mkkernel";
$MKLIBMC    ="$MPATH/utils/mklibmc";
$LINKER     ="not_valid_arch ";  # default value
if ($ARCH eq "x86") {
    $LINKER="ld ";
} elsif  ($ARCH eq "linux" || $ARCH eq "linux_lib") {
    $LINKER="gcc ";
} else {
    die "Unexpected architecture: $ARCH";
}

# GNAT RTS (and directories adainclude y adalib)
$GNAT_RTS=" --RTS=not_valid_RTS ";
$ADAINCLUDE="not_valid_adainclude";
$ADALIB="not_valid_adalib";

# Work with GNAT GPL-2005 as with GAP 2005
if ($GNAT_VERSION eq "GPL2005")
{
    $GNAT_VERSION = "GAP2005";
}

if ($GNAT_VERSION eq "GAP1.0"  || $GNAT_VERSION eq "GAP1.1"  ||
    $GNAT_VERSION eq "GAP2005" || $GNAT_VERSION eq "GPL2006" ||
    $GNAT_VERSION eq "Pro6.0.0w") {
    $GNAT_RTS=" --RTS=rts-sjlj "; # " --RTS=rts-native "     " --RTS=rts-sjlj "
    $GNAT_RTS_DIR="rts-sjlj";     # "rts-native"             "rts-sjlj"
    $ADAINCLUDE="$GNAT_RTS_DIR/adainclude";
    $ADALIB="$GNAT_RTS_DIR/adalib";
} elsif ($GNAT_VERSION eq "3.15" || $GNAT_VERSION eq "3.14") {
    $GNAT_RTS="";
    $GNAT_RTS_DIR="";
    $ADAINCLUDE="adainclude";
    $ADALIB="adalib";
} else {
    die "Unexpected GNAT version: $GNAT_VERSION";
}

# Includes
$INCLUDES="-Inot_valid_arch"; # default value
if ($ARCH eq "x86" || $ARCH eq "linux") {
    $INCLUDES="-nostdinc -I$MPATH/include";
} elsif  ($ARCH eq "linux_lib") {
    # I also want to use the standard includes in this architecture
    $INCLUDES="-I$MPATH/include";
} else {
    die "Unexpected architecture: $ARCH";
}

# Libs
$LIBS_PATH="-L$MPATH/lib ";

$LIBS_ARCH1=" -lnot_valid_arch "; # default value
$LIBS_ARCH2=" -lnot_valid_arch "; # default value
$LIB_DRIVERS=" -lnot_valid_arch "; # default value
if ($ARCH eq "x86") {
    $LIB_DRIVERS=" -ldrivers ";
    $LIBS_ARCH1= " -lboot ";
    $LIBS_ARCH2= " ";
} elsif  ($ARCH eq "linux") {
    $LIB_DRIVERS=" -ldrivers ";
    $LIBS_ARCH1= " -llinux -lsyscalls ";
    $LIBS_ARCH2= " ";
} elsif  ($ARCH eq "linux_lib") {
    $LIB_DRIVERS="";
    $LIBS_ARCH1= " -llinux -lsyscalls ";
    $LIBS_ARCH2= " ";
} else {
    die "Unexpected architecture: $ARCH";
}

$LIBS=" -lnot_valid_gnat_version "; # default value
if ($GNAT_VERSION eq "GAP1.0"  || $GNAT_VERSION eq "GAP1.1"  ||
    $GNAT_VERSION eq "GAP2005" || $GNAT_VERSION eq "GPL2006" ||
    $GNAT_VERSION eq "Pro6.0.0w") {
    $LIBS="-lmarte $LIB_DRIVERS -lmc $LIBS_ARCH1 $GNAT_PATH/$ADALIB/libgnat.a -lmc $LIBS_ARCH2 $GNAT_PATH/libgcc.a $GNAT_PATH/libgcc_eh.a -lmarte ";
} elsif ($GNAT_VERSION eq "3.15") {
    $LIBS_3_15="-lmarte $LIB_DRIVERS $LIBS_ARCH1 $GNAT_PATH/$ADALIB/libgnat.a -lmc $LIBS_ARCH2 $GNAT_PATH/libgcc.a -lmarte ";
} elsif ($GNAT_VERSION eq "3.14") {
    $LIBS_3_14="-lmarte $LIB_DRIVERS $LIBS_ARCH1 $GNAT_PATH/$ADALIB/libgnat.a -lmc $LIBS_ARCH2 $GNAT_PATH/libgcc.a -lmarte ";
} else {
    die "Unexpected GNAT version: $GNAT_VERSION";
}

# Compiler version depending options
$VER_OPS=" not_valid_gnat_version "; # default value
if ($GNAT_VERSION eq "GPL2006" || $GNAT_VERSION eq "Pro6.0.0w") {
    $VER_OPS="-fno-strict-aliasing -gnat05";
} elsif ($GNAT_VERSION eq "GAP1.0"  || $GNAT_VERSION eq "GAP1.1" ||
	 $GNAT_VERSION eq "GAP2005") {
    $VER_OPS="-fno-strict-aliasing";
} elsif ($GNAT_VERSION eq "3.15") {
    $VER_OPS="";
} elsif ($GNAT_VERSION eq "3.14") {
    $VER_OPS="";
} else {
    die "Unexpected GNAT version: $GNAT_VERSION";
}

# Architecture dependent gcc options
$ARCH_GCC_OPTS="  not_valid_arch ";  # default value
if ($ARCH eq "x86") {
    $ARCH_GCC_OPTS=" ";
} elsif  ($ARCH eq "linux") {
    $ARCH_GCC_OPTS=" -Dmain=user_main ";
} elsif  ($ARCH eq "linux_lib") {
    $ARCH_GCC_OPTS=" -Dmain=user_main ";
} else {
    die "Unexpected architecture: $ARCH";
}

# Architecture dependent gnatbind options
$ARCH_GNATBIND_OPTS="  not_valid_arch ";  # default value
if ($ARCH eq "x86") {
    $ARCH_GNATBIND_OPTS=" ";
} elsif  ($ARCH eq "linux") {
    $ARCH_GNATBIND_OPTS=" -Muser_main ";
} elsif  ($ARCH eq "linux_lib") {
    $ARCH_GNATBIND_OPTS=" ";
} else {
    die "Unexpected architecture: $ARCH";
}

# Architecture dependent linking options
$ARCH_LD_OPTS="  not_valid_arch ";  # default value
if ($ARCH eq "x86") {
    $ARCH_LD_OPTS=" -Ttext 100000 "; #-m elf_i386 -static
} elsif  ($ARCH eq "linux" || $ARCH eq "linux_lib") {
    $ARCH_LD_OPTS=" ";
} else {
    die "Unexpected architecture: $ARCH";
}

# Architecture dependent make options
$ARCH_MAKE_OPTS="  not_valid_arch ";  # default value
if ($ARCH eq "x86") {
    $ARCH_MAKE_OPTS="  ";
} elsif  ($ARCH eq "linux" || $ARCH eq "linux_lib") {
    $ARCH_MAKE_OPTS=" VIRTUAL_TIMER=$VIRTUAL_TIMER ";
} else {
    die "Unexpected architecture: $ARCH";
}


# Ada Code Locations
$ADA_CODE_LOCATIONS="-I$MPATH/kernel -I$MPATH/arch/hwi -I$MPATH/sll -I$MPATH/libmgnat -I$MPATH/misc -I$MPATH/posix5";

# Architecture depending objects files
$CRTI_0   = "";  # default value
$CTRN_O   = "";  # default value
$_EXIT_O  = "";  # default value
if ($ARCH eq "x86") {
    $CRTI_0   = " $MPATH/lib/multiboot.o " .
                "$MPATH/arch/call_main/base_multiboot_main.o ";
    $CRTN_O   = " $MPATH/lib/crtn.o ";
    $_EXIT_O  = "";
} elsif  ($ARCH eq "linux" || $ARCH eq "linux_lib") {
    $CRTI_0   = "  ";
    $CRTN_O   = "  ";
    $_EXIT_O  = "$MPATH/arch/call_main/_exit.o ";
}
$WRAPPER_MAIN_C_O   = "$MPATH/arch/call_main/wrapper_main_c.o ";
$WRAPPER_MAIN_CPP_O = "$MPATH/arch/call_main/wrapper_main_cpp.o ";
$WRAPPER_MAIN_ADA_O = "$MPATH/arch/call_main/wrapper_main_ada.o ";
if  ($ARCH eq "linux_lib") {
    $WRAPPER_MAIN_ADA_O = " ";
}
if  ($ARCH eq "x86") {
    $WRAPPER_MAIN_CPP_O = $WRAPPER_MAIN_C_O;
}


# Objects files location
$KERNEL_OBJS_LIBMARTE="$MPATH/kernel/*.o $MPATH/arch/hwi/*.o $MPATH/sll/*.o $MPATH/libmgnat/*.o $MPATH/misc/*.o $MPATH/kernel/dynamic_memory/*.o ";

# krunching
$KRUNCHING_LENGTH = "320";
$KRUNCHING = "-gnatk320";

# architecture dependent program name
$PROG_NAME   = "mprogram";  # default value
$CP_PROGRAM   = " not a valid architecture ";  # default value
if ($ARCH eq "x86") {
    if ($ADD_HOSTNAME_TO_MPROGRAM eq "TRUE") {
	open (SYS_OUT, "hostname -s |");
	$hostname = <SYS_OUT>;
	$hostname =~ s/\n//;
	$PROG_NAME="$EXPORTED_DIR/$PROG_NAME" . "_" . $hostname;
	$CP_PROGRAM="";
    } else {
	# Program name
	$PROG_NAME="$MPATH/mprogram";

	# Copy program
	$CP_PROGRAM="cp $PROG_NAME $EXPORTED_DIR";
	#$CP_PROGRAM="echo TO BOCHS; mcopy -o $PROG_NAME m:";
    }
} elsif  ($ARCH eq "linux" || $ARCH eq "linux_lib") {
    # Program name
    $PROG_NAME="mprogram";

    # Copy program
    $CP_PROGRAM="";
} else {
    die "Unexpected architecture: $ARCH";
}

# Remove unneeded from the kernel
$RM_UNNEEDED="objcopy -O elf32-i386 --remove-section=.comment --remove-section=.note --strip-unneeded $PROG_NAME";
# $RM_UNNEEDED="objcopy -O elf32-i386 --remove-section=.comment --remove-section=.anno --remove-section=.note --remove-section=.eh_frame --remove-section=.ctors --remove-section=.dtors --strip-all $PROG_NAME";

