#include <pthread.h>
#include <stdio.h>
#include <stdint.h>
#include <misc/error_checks.h>
#include <unistd.h>
#include "../rtep.h"

static uint16_t mutex_id = 1;

void job1 (void)
{
   printf ("job1\n");

   while (1) {
      sleep (1);
      printf ("Lock\n");
      rtep_lock_distributed_mutex (mutex_id);
      printf ("Mutex FOR ME!\n");
      sleep (4);
      rtep_unlock_distributed_mutex (mutex_id);
      printf ("Mutex RELEASED!\n");
      sleep (10);
   }
}

void job2 (void)
{
   printf ("job2\n");

   while (1) {
      sleep (1);
      printf ("Lock\n");
      rtep_lock_distributed_mutex (mutex_id);
      printf ("Mutex FOR ME!\n");
      sleep (4);
      rtep_unlock_distributed_mutex (mutex_id);
      printf ("Mutex RELEASED!\n");
      sleep (10);
   }
}

void job3 (void)
{
   printf ("job3\n");

   while (1) {
      sleep (1);
      printf ("Lock\n");
      rtep_lock_distributed_mutex (mutex_id);
      printf ("Mutex FOR ME!\n");
      sleep (4);
      rtep_unlock_distributed_mutex (mutex_id);
      printf ("Mutex RELEASED!\n");
      sleep (10);
   }
}

int main ()
{
   uint16_t me;
   uint16_t mutex_multicast;
   uint16_t mutex_budget = 2; /* packets */
   int mutex_period = 10; /* 10 secs */
   uint8_t mutex_prio = 5;
   uint16_t server;
   char mutex_multicast_name[] = "broadcast";

   /* initialization */
   rtep_adainit();
   rtep_init_comm();

   /* Create a server for the mutex messages */
   rtep_server_create(mutex_budget, mutex_period, 0, mutex_prio, &server);

   /* The mutex can be shared by a subset of the stations */
   mutex_multicast = rtep_get_station_id_by_name
      ((uint8_t *)mutex_multicast_name, sizeof(mutex_multicast_name)-1);

   /* Init the distributed mutex */

   if (rtep_init_distributed_mutex (mutex_id, mutex_multicast, server) != 0) {
      printf ("ERROR rtep_init_distributed_mutex\n");
      return -1;
   }

   // call the appropiate procedure
   me = rtep_get_station_id();
   switch (me) {
      case 1:
         job1 ();
         break;
      case 2:
         job2 ();
         break;
      case 3:
         job3 ();
         break;
   };

   // finalization
   rtep_adafinal();
   return 0;
}
